#include "WindowInterface.h"
#include "ObserverConnector.hpp"
#include "MyObserver.h"
#include <iostream>
#include <memory>
#include "WindowVisitor.h"

using namespace std;

int main()
{
	DialogBox d;
	Button b1("AAA");
	Button b2("BBB");
	MyObserver obsA("OBSA");
	MyObserver obsB("OBSB");

	ObserverConnector<DialogBox, MyObserver> conn1(d, obsA);
	ObserverConnector<Button, MyObserver> conn2(b1, obsA);
	ObserverConnector<Button, MyObserver> conn3(b2, obsB);

	d.addObserver(&conn1);
	b1.addObserver(&conn2);
	b2.addObserver(&conn3);

	d.changeSize(5);
	d.changeSize(3);
	b1.click();
	b2.click();
	b2.release();
	b1.release();

	WindowVisitor visitor;

	d.accept(visitor);
	b1.accept(visitor);
}
